## Script (Python) "events.ids.py"
##title=Events in iCalendar format
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath

RESPONSE = container.REQUEST.RESPONSE
RESPONSE.setHeader('Content-Type', 'text/calendar')
RESPONSE.setHeader('Content-Disposition', 'attachment; filename="events.ics"')

# iCal header and footer
ICS_HEADER = """\
BEGIN:VCALENDAR
PRODID:-//AT Content Types//AT Event//EN
VERSION:2.0
METHOD:PUBLISH
"""

ICS_FOOTER = """\
END:VCALENDAR
"""

zcat=context.portal_catalog
cal=context.portal_calendar

print ICS_HEADER,
for objCat in zcat(portal_type=cal.getCalendarTypes(),
                   review_state=cal.getCalendarStates(),
                   start=DateTime().earliestTime(),
                   start_usage='range:min',
		   path=context.mpParentPath(),):
    obj=objCat.getObject()
    print obj.getICal(),
print ICS_FOOTER,

return printed.replace('\n', '\r\n')

