## Script (Python) "miniPortalNavTree.py"
##title=Create NavTree rooted at MiniPortal
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=sitemap=None

# if inside a MiniPortal, return a NavTree rooted at the MiniPortal;
# otherwise, return the normal NavTree

nt = context.plone_utils.createNavTree(context, sitemap)

if hasattr(context,"miniPortalParent"):
    mppath = context.getMiniPortalPath()

    todo = nt['children']
    while todo:
        current = todo.pop()
        if current['path'] == mppath:
            nt = current
            break
        todo.extend(current.get('children', []))

return nt
