## Script (Python) "publicMiniPortals"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Find MiniPortals
##
# returns a list of dictionaries for public mini portals
# only picks up mini portals in portal folder
from Products.CMFCore.utils import getToolByName
portal_catalog = getToolByName(context, 'portal_catalog')
currentPath = '/'.join(context.getPhysicalPath())
miniPortals = portal_catalog( portal_type = 'MiniPortal', sort_on = 'sortable_title', path={'query':currentPath, 'navtree':1, 'depth': 1} )
return [ {'Title':obj.Title, 'Description':obj.Description, 'getURL':obj.getRemoteUrl or obj.getURL()}
 for obj in miniPortals if not obj.exclude_from_nav ]

